package ssw.mj;

import java.util.ArrayList;
import java.util.List;

public class Errors {
	/** List of error messages. */
	private static List<String> errors;

	
	// TODO Exercise 4: Error handling with recovery

	
	/** 
	 * Initialization (must be called before compilation).
	 */
	public static void init() {
		errors = new ArrayList<String>();
	}

	/**
	 * Add a new error messsage to the list of errors.
	 */
	public static void error(int line, int col, String msgKey, Object... msgParams) {
		errors.add("-- line " + line + " col " + col + ": " + Messages.getString(msgKey, msgParams));
	}

	/**
	 * Returns the number of errors.
	 */
	public static int numErrors() {
		return errors.size();
	}

	/**
	 * String representation for JUnit test cases. 
	 */
	public static String dump() {
		StringBuilder sb = new StringBuilder();
		for (String error : errors) {
			sb.append(error);
			sb.append("\n");
		}
		return sb.toString();
	}
}



