package ssw.mj;

import ssw.mj.codegen.Code;
import ssw.mj.symtab.Tab;

/** 
 * The Parser for the MicroJava Compiler. 
 */
public class Parser {
	/** Last recognized token; */
	private static Token t;
  
	/** Lookahead token (not recognized).) */
	private static Token la;
  
	/** Shortcut to kind attribute of lookahead token (la). */
	private static int sym;

	
	/**
	 * Adds error message to the list of errors.
	 */
	public static void error(String msgKey, Object... msgParams) {
		Errors.error(la.line, la.col, msgKey, msgParams);
		// panic mode
		throw new Error(Messages.getString("PANIC_MODE"));
	}

	
	// TODO Exercise 3 - 6: implementation of parser
	
	
	/**
	 *  Initializes the parser and all its components.
	 */
	private static void init() {
		Tab.init();
		Code.init();
	}
	
	/**
	 * Starts the analysis.
	 */
	public static void parse() {
		init();               // initialize parser and all dependent components 
	}
}
